<template>
  <b-modal
    id="aimsReviewModal"
    v-model="isOpen"
    :title="$t('aims.reviewModalTitle')"
    :cancel-disabled="mergeRequestUrl !== null"
    :cancel-title="$t('Cancel')"
    :ok-disabled="loading || !community"
    :ok-title="mergeRequestUrl ? $t('Continue') : $t('SendToReview')"
    @ok.prevent="save"
    @cancel="close"
    @close="close"
    @hidden="hidden"
  >
    {{
      mergeRequestUrl
        ? $t("aims.reviewedModalDescription")
        : $t("aims.reviewModalDescription")
    }}
    <hr />
    <b-input-group v-if="mergeRequestUrl" class="mt-2">
      <b-form-input
        id="mergeRequest"
        :disabled="true"
        :state="copied ? true : null"
        :model-value="mergeRequestUrl"
        trim
      />

      <template #append>
        <b-button variant="outline-secondary" @click="copyToClipboard">
          <i-bi-clipboard />
        </b-button>
        <b-button
          :href="mergeRequestUrl"
          target="_blank"
          variant="outline-secondary"
        >
          <i-bi-link45deg />
        </b-button>
      </template>
    </b-input-group>
    <div v-else>
      <label
        :id="'communitiesLabel'"
        class="form-label d-inline-flex gap-1 align-items-center"
        for="communities"
        >{{ $t("communitiesLabel") }} <i-bi-question-circle-fill
      /></label>
      <b-tooltip :target="'communitiesLabel'" triggers="hover" noninteractive>{{
        $t("communitiesDescription")
      }}</b-tooltip>
      <b-form-select
        id="communities"
        v-model="community"
        :placeholder="$t('communitiesLabel')"
        :disabled="loading"
        :options="communities"
      >
        <template #first>
          <b-form-select-option :value="null">{{
            $t("pleaseSelectOption")
          }}</b-form-select-option>
        </template>
      </b-form-select>
    </div>
  </b-modal>
</template>

<script lang="ts">
import { defineComponent, type PropType } from "vue";

import serviceProvider from "@/util/service-providers/service-provider";
import AIMSServiceProvider from "@/util/service-providers/aims/aims-service-provider";
import type { ApplicationProfile } from "@/types/application-profile";

export default defineComponent({
  name: "AimsReviewModal",
  props: {
    applicationProfile: {
      required: true,
      type: Object as PropType<ApplicationProfile>,
    },
    open: {
      required: true,
      default: () => false,
      type: Boolean,
    },
  },
  data() {
    return {
      community: null as null | string,
      communities: [] as { value: string; text: string }[],
      copied: false,
      loading: false,
      isOpen: false,
      mergeRequestUrl: null as null | string,
    };
  },
  watch: {
    applicationProfile() {
      this.mergeRequestUrl = null;
    },
    open() {
      this.isOpen = this.open;
    },
  },
  mounted() {
    this.copied = false;
    this.retrieveCommunities();
  },
  methods: {
    close() {
      this.isOpen = false;
    },
    async copyToClipboard() {
      if (this.mergeRequestUrl) {
        await navigator.clipboard.writeText(this.mergeRequestUrl);
        this.copied = true;
      }
    },
    hidden() {
      this.$emit("close");
    },
    async save() {
      if (this.mergeRequestUrl) {
        this.$emit("save");
      } else if (this.community) {
        this.loading = true;
        this.mergeRequestUrl = await (
          serviceProvider as AIMSServiceProvider
        ).apiConnection.sendApplicationProfileForReview(
          this.applicationProfile,
          this.community,
        );
        this.loading = false;
      }
    },
    async retrieveCommunities() {
      if (serviceProvider.apiConnection.getCommunities) {
        this.loading = true;
        const communityList =
          await serviceProvider.apiConnection.getCommunities();
        this.communities = communityList.map((x) => {
          return {
            text: x.name,
            value: x.name,
          };
        });
        this.loading = false;
      }
    },
  },
});
</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped></style>
